<template>
    <nav aria-label="listing pagination">
        <ul class="pagination justify-content-center padding">
            <li class="page-item" v-bind:class="{ disabled: currentPage === 1 }">
                <a class="page-link" @click.prevent="previous()" tabindex="-1">Previous</a>
            </li>


            <li v-for="n in this.lastPage" :key="n" class="page-item" v-bind:class="{ active: currentPage === n }">
                <a class="page-link" @click.prevent="toPage(n)">{{n}} <span class="sr-only">(current)</span></a>
            </li>


            <li class="page-item" v-bind:class="{ disabled: currentPage === lastPage }">
                <a class="page-link" @click.prevent="next()">Next</a>
            </li>
        </ul>
    </nav>
</template>

<script>
    import {mapGetters} from "vuex";
    import {mapState} from 'vuex'


    export default {
        name: "Paginator",
        data() {
            return {};
        },
        computed: {
            // mix the getters into computed with object spread operator
            ...mapGetters([
                'currentPage',
                'lastPage',
                // ...
            ]),
            ...mapState({
            form: state => state.form
        }),
        },
        methods: {
            toPage(page) {
                this.$store.dispatch('getListings', this.form.populate({
                    page: page,
                })).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            },
            onSuccess(response) {
                this.$store.dispatch('setListings', response.data)
                this.$store.dispatch('setCurrentPage', response.current_page)
                this.$store.dispatch('setLastPage', response.last_page)
            },
            onError(response) {
                console.log(response)
            },
            next() {
                if (this.currentPage + 1 > this.lastPage) {
                    return
                }
                this.$store.dispatch('getListings', this.form.populate({
                    page: this.currentPage + 1,
                })).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            },
            previous() {
                if (this.currentPage - 1 === 0) {
                    return
                }
                this.$store.dispatch('getListings', this.form.populate({
                    page: this.currentPage - 1,
                })).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            }
        }
    }
</script>

<style scoped>
    .padding {
        margin-top: 40px;
        margin-bottom: 40px;
    }

    .page-item {
        cursor: pointer;
    }
</style>
